// this code is programed auto by dialog editor.
#include "_APPNAME_Dialog_DIALOGNAME_.h"


#define debugs  { cout << __FILE__ << ':' << __LINE__ << ':' << __FUNCTION__ << endl; }

//--------------------------------------------------------------------------------------
// コンストラクタ
_APPNAME_Dialog_DIALOGNAME_::_APPNAME_Dialog_DIALOGNAME_()
{
	debugs;
}

//--------------------------------------------------------------------------------------
// デストラクタ
_APPNAME_Dialog_DIALOGNAME_::~_APPNAME_Dialog_DIALOGNAME_()
{
	debugs;
}



//--------------------------------------------------------------------------------------
// 初期化処理
void _APPNAME_Dialog_DIALOGNAME_::OnInit()
{
	debugs;
	// セッションが確立し、ダイアログが新規に作成されたときに呼ばれます。
	// ダイアログ生成時に１度だけ行う初期化処理を行って下さい。

	// タイマーを使用する場合のサンプルコード
//	SetTimerInterval(5000,123);
}

//--------------------------------------------------------------------------------------
// ダイアログ遷移前通知
// pgsock 通信ソケット
// jo     JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnChangeBefore( PGClientSocket *pgsock, PGJsonCommand *jo )
{
	debugs;
	// 端末がダイアログを遷移する直前に呼ばれます（遷移する前の現在のダイアログが受け取る通知）
}

//--------------------------------------------------------------------------------------
// ダイアログ遷移通知
// pgsock 通信ソケット
// jo     JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnChange( PGClientSocket *pgsock, PGJsonCommand *jo )
{
	debugs;
	// 端末がダイアログを遷移した直後に呼ばれます。（表示された新しいダイアログが受け取る通知）
	// 端末はダイアログの内容が初期値のままの状態です。
	// セッションごとに個別に保持している内容を対象の端末へ送信（更新）する必要があります。

	// 初回のみ個別エリアにダイアログ情報をロードします。
	if( LoadJsonUnique( pgsock->mSessionId ) ){
		// 初回のみの処理を行う
	}
	
	// 個別の端末へUPDATEを送信する
	SendUpdateUnique(pgsock->mSessionId,true);
}


//--------------------------------------------------------------------------------------
// 状態変更通知
// pgsock 通信ソケット
// jo     JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnCondition( PGClientSocket *pgsock, PGJsonCommand *jo )
{
	debugs;
	// クリックやタイマーなど予め登録したトリガで、端末の状態がCONDITIONコマンドで
	// 送信されてきた時によばれます。

	// この要求をしているセッション専用のリソース領域が存在するか確認する
	if( mSessionResourceList.count( pgsock->mSessionId )<=0 ) return;

	// 端末の状態をセッション専用のリソース領域へ反映
	// この関数コールにより OnUpdate がコールバックされます。
	UpdateResourceUnique( jo, pgsock->mSessionId );
}


//--------------------------------------------------------------------------------------
// 各オブジェクトの状態変更通知（更新オブジェクトの数だけ繰り返し呼ばれます）
// to     JSONコマンドオブジェクト
// from   JSONコマンドオブジェクト
void _APPNAME_Dialog_DIALOGNAME_::OnUpdate(PGJsonObject* to ,PGJsonObject* from)
{
	// 基本クラス内で更新処理が行われ、受信した更新内容をリソース内へ取り込みます。
	PGDialog::OnUpdate(to,from);
}

//--------------------------------------------------------------------------------------
// 端末が CONDITION コマンドを送信するトリガになったオブジェクトのコールバック通知関数
// pgsock     受信ソケット
// jobj       トリガとなったオブジェクト（Json）
// actiontype トリガとなった要因
//            ・Clicked       オブジェクトがクリックされた
//            ・ItemClicked   GRIDで表示された項目がクリックされた
//            ・ItemSelected  PULLDOWNで表示された項目が選択された
//            ・SlideTouched  SLIDEBARのつまみが押下された（ドラッグ開始）
//            ・SlideMoved    SLIDEBARのつまみが変化した（ドラッグ中）
//            ・SlideReleased SLIDEBARのつまみが離された（ドラッグ終了）
//            ・Timer         指定した時間が経過した
void _APPNAME_Dialog_DIALOGNAME_::OnTouch( PGClientSocket *pgsock, PGJsonObject *jobj ,const SGString actiontype )
{
	// 端末が CONDITION コマンドを受信するきっかけになったオブジェクトを知ることができます。
	// 押されたボタンに対する処理などを行って下さい。
	// トリガオブジェクトの名前は jobj->GetValue("Name") で取得できます。
	// リソースを変更する場合は GetResourceUnique(pgsock->mSessionId) で個別のリソースが取得できます。
	// リソースを変更した場合は、個別の端末へUPDATEを送信する為に SendUpdateUnique(pgsock->mSessionId); を実行して下さい。

	// タッチされたオブジェクト名を取得
	SGString name = jobj->GetValue("Name").GetString();
	cout << "OnTouch = Name:" << name << " ,Action:" << (const char*)actiontype << endl;

	// name をチェックして、トリガオブジェクトに対する処理を行う

	// 個別の端末へUPDATEを送信する
	// 更新が行われたオブジェクトの更新が行われた要素だけを送信します。
	SendUpdateUnique(pgsock->mSessionId);
}


//--------------------------------------------------------------------------------------
// タイマー通知
//   SetTimerInterval(間隔ms,ID);を実行した際に、時間が経過したことを通知する関数
// time  タイマ発生時刻
// id    登録時にセットしたID
void _APPNAME_Dialog_DIALOGNAME_::OnTimer(TimeVal time,unsigned int id)
{
	debugs;
}

//--------------------------------------------------------------------------------------
// 終了通知
void _APPNAME_Dialog_DIALOGNAME_::OnFinal()
{
	debugs;
	// このダイアログを見ている全てのセッションがなくなったときに呼ばれます
}


